{
Copyright (C) 2002-2020  Massimo Melina (www.rejetto.com)

This file is part of HFS ~ HTTP File Server.

    HFS is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    HFS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HFS; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Unit created, internationalized & localized for HFS ~ HTTP File Server by SilentPliz - 2011-2020  <silentpliz@gmail.com>
}

unit InputQueryFrm_F;  //added by SilentPliz 2010
 
interface
 
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, gnugettext;
 
type
  TInputQueryFrm = class(TForm)
    EditInput: TEdit;
    LabelLegende: TLabel;
    bottomPnl: TPanel;
    okBtn: TButton;
    cancelBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bottomPnlResize(Sender: TObject);
    procedure EditInputKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    function GetInput: String;
    function GetLegende: String;
    procedure SetInput(const Value: String);
    procedure SetLegende(const Value: String);
    { Dclarations prives }
  public
    { Dclarations publiques }
    property Legende: String read GetLegende write SetLegende;
    property Input: String read GetInput write SetInput;
  end;
 
var
  InputQueryFrm: TInputQueryFrm;
 
function MyInputQuery(const _Caption, _Legende : String; var _Input : String): boolean;
 
 
implementation
 
{$R *.dfm}
 
function MyInputQuery(const _Caption, _Legende : String; var _Input : String): boolean;
begin
  with TInputQueryFrm.Create(Application) do
  begin
    try
      Caption := _Caption;
      Legende := _Legende;
      Input := _Input;
      Result := ShowModal = okBtn.ModalResult;
      if Result then
        _Input := Input;
    finally
      Release;
    end;
  end;
End;
 
{ TInputQueryFrm }
 
function TInputQueryFrm.GetInput: String;
begin
  Result := EditInput.Text;
end;
 
function TInputQueryFrm.GetLegende: String;
begin
  Result := LabelLegende.Caption;
end;

procedure TInputQueryFrm.SetInput(const Value: String);
begin
  EditInput.Text := Value;
end;
 
procedure TInputQueryFrm.SetLegende(const Value: String);
begin
  LabelLegende.Caption := Value;
end;

procedure TInputQueryFrm.bottomPnlResize(Sender: TObject);
begin
okBtn.left:=(bottomPnl.Width-cancelBtn.BoundsRect.right+okBtn.BoundsRect.left) div 2;
cancelBtn.left:=okBtn.BoundsRect.Right+10;
end;

procedure TInputQueryFrm.EditInputKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if shift = [ssCtrl] then
  if key = ord('A') then
    EditInput.SelectAll();
end;

procedure TInputQueryFrm.FormCreate(Sender: TObject);
begin
  TranslateComponent (self);
  Legende := '';
end;

procedure TInputQueryFrm.FormShow(Sender: TObject);
begin
  RetranslateComponent (self); 
end;

end.

