{
Copyright (C) 2002-2020  Massimo Melina (www.rejetto.com)

This file is part of HFS ~ HTTP File Server.

    HFS is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    HFS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HFS; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Modified by Mars & SilentPliz - 2007/2020 - <silentpliz@gmail.com>
Internationalized & localized for HFS ~ HTTP File Server by SilentPliz - 2011-2020  <silentpliz@gmail.com>
}

unit ipsEverDlg; 

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, gnugettext;

type
  TipsEverFrm = class(TForm)
    totalLbl: TLabel;
    ipsBox: TMemo;
    resetBtn: TButton;
    editBtn: TButton;
    procedure resetBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure editBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure refreshData();
    { Public declarations }
  end;

var
  ipsEverFrm: TipsEverFrm;

implementation

{$R *.dfm}

uses
  main, utilLib;

procedure TipsEverFrm.resetBtnClick(Sender: TObject);
begin
ipsEverConnected.clear();
refreshData();
end;

procedure TipsEverFrm.editBtnClick(Sender: TObject);
var
  fn: string;
begin
fn:=saveTempFile(ipsEverConnected.text);
if renameFile(fn, fn+'.txt') then exec(fn+'.txt')
else msgDlg(_('Impossible d''enregistrer les fichiers temporaires.'), MB_ICONERROR, _('ERREUR'));
end;

procedure TipsEverFrm.FormCreate(Sender: TObject);
begin
  TranslateComponent (self);  //add by SilentPliz
self.DefaultMonitor:=dmMainForm;          //add by mars
self.Position:=poScreenCenter;            //add by mars
end;

procedure TipsEverFrm.FormShow(Sender: TObject);
begin
 refreshData();
RetranslateComponent (self); //add by SilentPliz
 end;

procedure TipsEverFrm.refreshData();
begin
ipsBox.text:=ipsEverConnected.text;
totalLbl.caption:=format(_('Total : %d'), [ipsEverConnected.count]);
repaintTray();
end; // refreshData

end.
